/*
 * FADE - Secure Overlay Cloud Storage with File Assured Deletion
 * Copyright (C) 2010  Yang Tang
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * @file ClientConfig.h
 * @author Yang Tang
 * @brief Client configuration file parser interface
 */

#ifndef FADE_CLIENT_CONFIG_H
#define FADE_CLIENT_CONFIG_H

#include <expat.h>

#if defined(__amigaos__) && defined(__USE_INLINE__)
#include <proto/expat.h>
#endif

#ifdef XML_LARGE_SIZE
#if defined(XML_USE_MSC_EXTENSIONS) && _MSC_VER < 1400
#define XML_FMT_INT_MOD "I64"
#else
#define XML_FMT_INT_MOD "ll"
#endif
#else
#define XML_FMT_INT_MOD "l"
#endif

/**
 * @brief Client configuration file parser
 */
class ClientConfig
{
	static void XMLCALL startElement(void *data, const char *el, const char **attr);
	static void XMLCALL endElement(void *data, const char *el);
public:
	/**
	 * Parse the configuration file
	 * @param filename The filename of the configuration file
	 */
	static void parse(const char *filename);
};

#endif /* FADE_CLIENT_CONFIG_H */
