/*
 * FADE - Secure Overlay Cloud Storage with File Assured Deletion
 * Copyright (C) 2010  Yang Tang
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * @file LocalStorage.h
 * @author Yang Tang
 * @brief Local storage interface
 */

#ifndef FADE_LOCAL_STORAGE_H
#define FADE_LOCAL_STORAGE_H

#include "Storage.h"

/**
 * @brief Local storage
 */
class LocalStorage : public Storage
{
	string dir;
public:
	/**
	 * @param dir The path of the local storage
	 */
	LocalStorage(const string &dir)
		: dir(dir) {}
	bool put(const string &filename) const;
	bool get(const string &filename) const;
};

#endif /* FADE_LOCAL_STORAGE_H */
