/*
 * FADE - Secure Overlay Cloud Storage with File Assured Deletion
 * Copyright (C) 2010  Yang Tang
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * @file S3Storage.h
 * @author Yang Tang
 * @brief Amazon S3 storage interface
 */

#ifndef FADE_S3_STORAGE_H
#define FADE_S3_STORAGE_H

#include <libaws/aws.h>
#include "Storage.h"

using namespace aws;

/**
 * @brief Amazon S3 storage
 */
class S3Storage : public Storage
{
	string bucket;
	S3ConnectionPtr s3Rest;
public:
	/**
	 * @param bucket The bucket name of the Amazon S3 storage
	 */
	S3Storage(const string &bucket);
	bool put(const string &filename) const;
	bool get(const string &filename) const;
};

#endif /* FADE_S3_STORAGE_H */
