/*
 * FADE - Secure Overlay Cloud Storage with File Assured Deletion
 * Copyright (C) 2010  Yang Tang
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * @file Panic.h
 * @author Yang Tang
 * @brief Panic thrower interface
 */

#ifndef FADE_PANIC_H
#define FADE_PANIC_H

/**
 * @brief Panic thrower
 */
class Panic
{
	Panic() {}
	~Panic() {}
public:
	/**
	 * Singleton instance
	 * @return The singleton instance of the Panic thrower
	 */
	static Panic *instance();

	/**
	 * Write an error message to stderr and halt the program
	 */
	void die(const char *fmt, ...) const;

	/**
	 * Write an error message to stderr and continue running
	 */
	void warn(const char *fmt, ...) const;
};

#endif /* FADE_PANIC_H */
