/*
 * FADE - Secure Overlay Cloud Storage with File Assured Deletion
 * Copyright (C) 2010  Yang Tang
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
 * @file Ephemerizer.h
 * @author Yang Tang
 * @brief FADE key manager interface
 */

#ifndef FADE_EPHEMERIZER_H
#define FADE_EPHEMERIZER_H

#include "PolicyForEphemerizer.h"

/**
 * @brief FADE key manager (formerly called Ephemerizer)
 */
class Ephemerizer
{
	int sockfd;
	Ephemerizer() {}
	~Ephemerizer() {}
	void closeSocket() const;
public:
	/**
	 * Singleton instance
	 * @return The singleton instance of FADE key manager
	 */
	static Ephemerizer *instance();

	/**
	 * Initialize the socket programming
	 */
	void initSocket();

	/**
	 * Start the key manager
	 */
	void run() const;
};

#endif /* FADE_EPHEMERIZER_H */
